INSERT INTO SF_VIEW_FS_CANNED_POLICY_R
ON EXISTING UPDATE VALUES
(
 '{FC57EA6A-171F-4db2-BD5D-02B8C1F37050}',
 'ssd_read_intensive_template',
 ''
);

INSERT INTO SF_VIEW_FS_CANNED_POLICY_R
ON EXISTING UPDATE VALUES
(
 '{1B08ACD0-CD90-4c1b-9B36-63D081F8D53F}',
 'ssd_dblog_and_tmp_template',
 ''
);

INSERT INTO SF_VIEW_FS_CANNED_POLICY_R
ON EXISTING UPDATE VALUES
(
 '{019FC034-7A11-4951-ABE9-4E29BC74EAF8}',
 'ssd_dbdata_and_index_template',
 ''
);


INSERT INTO SF_VIEW_FS_PLACEMENT_POLICY_R
ON EXISTING UPDATE VALUES
(
 '{FC57EA6A-171F-4db2-BD5D-02B8C1F37050}',
 0,
 '{FC57EA6A-171F-4db2-BD5D-02B8C1F37050}',
 0,
 'ssd_read_intensive_template',
 'The policy has two tiers ''tier1'' and a ''tier2''.\nThis policy could be used for any file system in the context of SSD storage.\n\nThis policy tries to reduce the SSD worn-out by placing read intensive files on SSD storage while evacuating write intesive files from there.\n\nThe tier1 can be staged on ssd storage and the tier2 can be staged on other storage.',
 '<?xml version="1.0"?><!DOCTYPE PLACEMENT_POLICY SYSTEM "/opt/VRTSvxfs/etc/placement_policy.dtd"><PLACEMENT_POLICY Version="5.1" Name="ssd_read_intensive_template"><COMMENT>The policy has two tiers ''tier1'' and a ''tier2''. This policy could be used for any file system in the context of SSD storage. This policy tries to reduce the SSD worn-out by placing read intensive files on SSD storage while evacuating write intesive files from there. The tier1 can be staged on ssd storage and the tier2 can be staged on other storage.</COMMENT><RULE Flags="data" Name="all_files"><COMMENT>The first two RELOCATEs will do the evacuation out of SSDs to create room for any relocations into the SSDs by the third RELOCATE. The parameters that can be tuned are basically values for PERIOD and the values of MIN and/or MAX as per the case. The values for MIN and MAX are treated as multiples of average activity over past 24 hour period.</COMMENT><SELECT><PATTERN> *</PATTERN></SELECT><CREATE><COMMENT>create files on tier1, failing which create them on other tiers</COMMENT><ON><DESTINATION Flags="any"><CLASS> tier1</CLASS></DESTINATION></ON></CREATE><RELOCATE><COMMENT>Move the files out of SSD if their last 3 hour write IOTEMP is more than 1.5 times the last 24 hour average write IOTEMP. The PERIOD is purposely shorter than the other RELOCATEs because we want to move it out as soon as write activity starts peaking.</COMMENT><FROM><SOURCE><CLASS> tier1</CLASS></SOURCE></FROM><TO><DESTINATION><CLASS> tier2</CLASS></DESTINATION></TO><WHEN><IOTEMP Type="nwbytes" Average="*"><MIN Flags="gt"> 1.5</MIN><PERIOD Units="hours"> 3</PERIOD></IOTEMP></WHEN></RELOCATE><RELOCATE><COMMENT>Move files out of SSD if their last 6 hour read IOTEMP is less than half the last 24 hour average read IOTEMP. The PERIOD is longer, since we may want to observe longer periods, having brought the file in. This avoids quickly moving the file out of SSDs once they are in.</COMMENT><FROM><SOURCE><CLASS> tier1</CLASS></SOURCE></FROM><TO><DESTINATION><CLASS> tier2</CLASS></DESTINATION></TO><WHEN><IOTEMP Type="nrbytes" Average="*"><MAX Flags="lt"> 0.5</MAX><PERIOD Units="hours"> 6</PERIOD></IOTEMP></WHEN></RELOCATE><RELOCATE><COMMENT>Move the files into SSD if their last 3 hour read IOTEMP is more than or equal to 1.5 times the last 24 hour average read IOTEMP AND their last 6 hour write IOTEMP is less than half of the last 24 hour average write IOTEMP</COMMENT><TO><DESTINATION><CLASS> tier1</CLASS></DESTINATION></TO><WHEN><IOTEMP Type="nrbytes" Prefer="high" Average="*"><MIN Flags="gteq"> 1.5</MIN><PERIOD Units="hours"> 3</PERIOD></IOTEMP><IOTEMP Type="nwbytes" Average="*"><MAX Flags="lt"> 0.5</MAX><PERIOD Units="hours"> 3</PERIOD></IOTEMP></WHEN></RELOCATE></RULE></PLACEMENT_POLICY>'
);

INSERT INTO SF_VIEW_FS_PLACEMENT_POLICY_R
ON EXISTING UPDATE VALUES
(
 '{1B08ACD0-CD90-4c1b-9B36-63D081F8D53F}',
 0,
 '{1B08ACD0-CD90-4c1b-9B36-63D081F8D53F}',
 0,
 'ssd_dblog_and_tmp_template',
 'This template could be used by DST for setting up databases in the context of SSD storage. This template assumes a common practice of keeping logs (undo and temp files) in one file system and data (data and index files) on a different file system.\n\nThis template could be used for file system hosting the logs (undo and temp files) of the data base.\nThe policy relocates database logs to tier1 storage for faster access.\n\nYou can use ssd_dbdata_and_index_template.xml for your filesystem that stores database data and index files.\n\nAppropriate modifications in below SELECT is required to specify the names of logs/temp files and/or their DIRECTORY locations.\n\nAlso note that this policy covers only the specific files in the SELECT. If the placement of anyother files on the same file system is desired, another RULE could be added with SELECT''s PATTERN of * to cover rest of the files.\n\nThe tier1 can be staged on SSD storage and the tier2 can be staged on other storage.',
 '<?xml version="1.0"?><!DOCTYPE PLACEMENT_POLICY SYSTEM "/opt/VRTSvxfs/etc/placement_policy.dtd"><PLACEMENT_POLICY Version="5.1" Name="ssd_dblog_and_tmp_template"><COMMENT>This template could be used by DST for setting up databases in the context of SSD storage. This template assumes a common practice of keeping logs (undo and temp files) in one file system and data (data and index files) on a different file system. This template could be used for file system hosting the logs (undo and temp files) of the data base. The policy relocates database logs to tier1 storage for faster access. You can use ssd_dbdata_and_index_template.xml for your filesystem that stores database data and index files. Appropriate modifications in below SELECT is required to specify the names of logs/temp files and/or their DIRECTORY locations. Also note that this policy covers only the specific files in the SELECT. If the placement of anyother files on the same file system is desired, another RULE could be added with SELECT''s PATTERN of * to cover rest of the files. The tier1 can be staged on SSD storage and the tier2 can be staged on other storage.</COMMENT><RULE Flags="data" Name="redo_or_undo_or_temp_files"><COMMENT>Note this RULE has no CREATE, because of which the frequently accessed files such as logs and temporary files permanently reside on tier1. This template could be used for existing databases which are coming under DST afresh or a new database deployment under DST, both with SSD storage.</COMMENT><SELECT><COMMENT>A tentative PATTERN is specified as a template filler that need to be replaced by appropriate pattern (like for instance *.tmp etc) to SELECT those files. Data bases use their own naming convention for log files and these names could be obtained by querying the database or other database specific practices. This template needs to be updated with those names in the PATTERN below. If multiple files are involved, as many PATTERN elements need to be repeated. The sample below has to be changed as per requirements.</COMMENT><PATTERN>*.log</PATTERN></SELECT><RELOCATE><COMMENT>Relocate all the SELECTed files unconditionally into SSD tier FROM wherever they may be, at the earliest opportunity.</COMMENT><TO><DESTINATION><CLASS> tier1 </CLASS></DESTINATION></TO></RELOCATE></RULE></PLACEMENT_POLICY>'
);

INSERT INTO SF_VIEW_FS_PLACEMENT_POLICY_R
ON EXISTING UPDATE VALUES
(
 '{019FC034-7A11-4951-ABE9-4E29BC74EAF8}',
 0,
 '{019FC034-7A11-4951-ABE9-4E29BC74EAF8}',
 0,
 'ssd_dbdata_and_index_template',
 'This template could be used by DST for setting up databases in the context of SSD storage. This template assumes a common practice of keeping logs (undo and temp files) in one file system and data (data and index files) on a different file system.\n\nThis template could be used for file system hosting the data (data and index files) of the data base.\nThe policy has two tiers ''tier1'' and a ''tier2''\n\nIt proposes two RULEs, first one for index files based on ACCESSTEMP and second one for rest of the files including data files, based on IOTEMP. The first RULE could be eliminated, should one decide to place all the files including indices based on IOTEMP itself.\n\nYou can use ssd_dblog_and_tmp_template.xml for your filesystem that stores database log and temp files.\n\nThe tier1 could be out of ssds and the tier2 will be out of other storage.',
 '<?xml version="1.0"?><!DOCTYPE PLACEMENT_POLICY SYSTEM "/opt/VRTSvxfs/etc/placement_policy.dtd"><PLACEMENT_POLICY Version="5.1" Name="ssd_dbdata_and_index_template"><COMMENT>This template could be used by DST for setting up databases in the context of SSD storage. This template assumes a common practice of keeping logs (undo and temp files) in one file system and data (data and index files) on a different file system. This template could be used for file system hosting the data (data and index files) of the data base. The policy has two tiers ''tier1'' and a ''tier2'' It proposes two RULEs, first one for index files based on ACCESSTEMP and second one for rest of the files including data files, based on IOTEMP. The first RULE could be eliminated, should one decide to place all the files including indices based on IOTEMP itself. You can use ssd_dblog_and_tmp_template.xml for your filesystem that stores database log and temp files. The tier1 could be out of ssds and the tier2 will be out of other storage.</COMMENT><RULE Flags="data" Name="index_files"><COMMENT>The first RELOCATE will do the evacuation out of SSDs to create room for any relocations into the SSDs by the second RELOCATE. The parameters that can be tuned are basically values for PERIOD and the values of MIN and/or MAX as per the case. The values for MIN and MAX are treated as multiples of average IO activity over past 24 hour period.</COMMENT><SELECT><COMMENT>A tentative PATTERN is specified as a template filler that need to be replaced by appropriate pattern (like for instance *.idx etc) to SELECT index files. Databases use their own naming convention for index files and these names could be obtained by querying the database or other database specific practices. This template needs to be updated with those names in the PATTERN below. If multiple files are involved, as many PATTERN elements need to be repeated. The sample below has to be changed as per requirements.</COMMENT><PATTERN> *.idx </PATTERN></SELECT><CREATE><COMMENT>create index files on tier1, failing which create them on other tiers</COMMENT><ON><DESTINATION Flags="any"><CLASS> tier1 </CLASS></DESTINATION></ON></CREATE><RELOCATE><COMMENT>Move the indices out of SSD if their last 6 hour read-write ACCESSTEMP is less than 0.5 times the last 24 hour average read-write ACCESSTEMP. The value of PERIOD is larger than the 2nd RELOCATE so that once the files have been brought into tier1 they do not get moved out too quickly.</COMMENT><TO><DESTINATION><CLASS> tier2 </CLASS></DESTINATION></TO><WHEN><ACCESSTEMP Type="nrws" Average="*"><MAX Flags="lt"> 0.5 </MAX><PERIOD Units="hours"> 6 </PERIOD></ACCESSTEMP></WHEN></RELOCATE><RELOCATE><COMMENT>Move the indices into SSD if their last 3 hours read-write ACCESSTEMP is more than or equal to 1.5 times the last 24 hour average read-write IOTEMP. The PERIOD is smaller than the earlier RELOCATE. The idea is to move the files into SSD at the earliest detection of high ACCESS activity. If multiple indices satisfy the ACCESSTEMP thresholds, give preference to files with higher ACCESSTEMP. </COMMENT><TO><DESTINATION><CLASS> tier1 </CLASS></DESTINATION></TO><WHEN><ACCESSTEMP Type="nrws" Prefer="high" Average="*"><MIN Flags="gteq"> 1.5 </MIN><PERIOD Units="hours"> 3 </PERIOD></ACCESSTEMP></WHEN></RELOCATE></RULE><RULE Flags="data" Name="rest_of_the_files_including_data_files"><COMMENT>The first RELOCATE will do the evacuation out of SSDs to create room for any relocations into the SSDs by the second RELOCATE. The parameters that can be tuned are basically values for PERIOD and the values of MIN and/or MAX as per the case. The values for MIN and MAX are treated as multiples of average IO activity over past 24 hour period.</COMMENT><SELECT><PATTERN> * </PATTERN></SELECT><CREATE><COMMENT>create files on tier1, failing which create them on other tiers</COMMENT><ON><DESTINATION Flags="any"><CLASS> tier1 </CLASS></DESTINATION></ON></CREATE><RELOCATE><COMMENT>Move the files out of SSD if their last 6 hour read-write IOTEMP is less than 0.5 times the last 24 hour average read-write IOTEMP. The value of PERIOD is larger than the 2nd RELOCATE so that once the files have been brought into tier1 they do not get moved out too quickly.</COMMENT><TO><DESTINATION><CLASS> tier2 </CLASS></DESTINATION></TO><WHEN><IOTEMP Type="nrwbytes" Average="*"><MAX Flags="lt"> 0.5 </MAX><PERIOD Units="hours"> 6 </PERIOD></IOTEMP></WHEN></RELOCATE><RELOCATE><COMMENT>Move the files into SSD if their last 3 hour read-write IOTEMP is more than or equal to 1.5 times the last 24 hour average read-write IOTEMP. The PERIOD is smaller than the earlier RELOCATE. The idea is to move the files into SSD at the earliest detection of high IO activity. If multiple files satisfy the IOTEMP thresholds, give preference to files with higher IOTEMP.</COMMENT><TO><DESTINATION><CLASS> tier1 </CLASS></DESTINATION></TO><WHEN><IOTEMP Type="nrwbytes" Prefer="high" Average="*"><MIN Flags="gteq"> 1.5 </MIN><PERIOD Units="hours"> 3 </PERIOD></IOTEMP></WHEN></RELOCATE></RULE></PLACEMENT_POLICY>'
);
