#!/opt/VRTSsfmh/bin/perl

BEGIN { @INC = ("/opt/VRTSsfmh/lib/modules") if ( $^O !~ /Win32/i ) }
use VRTS::AddOnInfo;
use VRTS::Util;
use VRTS::OS;
use File::Copy;
use Archive::Tar;

require File::Path;
require File::Spec;


	#This is for CS
	my $addon_dir = VRTS::Paths::get_path("DeployStoreDir");

	if ($^O =~ /Win32/i) {
		$addon_dir = $addon_dir."\\VRTSsfmvtp-5.0.196.01";
	} else {
		$addon_dir = $addon_dir."VRTSsfmvtp-5.0.196.01";
	}

	my $install_dir = VRTS::Paths::get_path("InstallDir");
	my $mhinstall_dir = File::Spec->canonpath($install_dir);
	my $csinstall_dir = $mhinstall_dir;
	$csinstall_dir =~ s/VRTSsfmh/VRTSsfmcs/;

    my $from_helpDir = File::Spec->catdir($addon_dir,"cms","EN_US");
    my $helpDir = File::Spec->catdir($csinstall_dir ,"esmweb", "webgui","symhelp","Content","EN_US");
    my @extractedHelpDirs = ("VOMSPADDONCURRENT");

	my $EX_PACKAGE = 1;
	my $EX_DB_TABLES = 2;
	my $XML = File::Spec->catfile($addon_dir, "cms", "VolTmplCache.xml");
	my $SXML1 = File::Spec->catfile($addon_dir, "cms", "voltmpl-servlet.xml");
	my $SXML2 = File::Spec->catfile($addon_dir, "cms", "voltmplmgr-servlet.xml");
	my $JAR1 = File::Spec->catfile($addon_dir, "cms", "VolTmpl.ext.jar");
	my $JAR2 = File::Spec->catfile($addon_dir, "cms", "VolTmpl.help.jar");
	my $JAR3 = File::Spec->catfile($addon_dir, "cms", "VolTmpl.help_ja_JP.jar");
	my $TAR = File::Spec->catfile($addon_dir, "cms", "VolTmpl.server.tar");

	my $destdir;


	$destdir = File::Spec->catfile($csinstall_dir, "esmweb", "precache", "web");
	copy($XML, $destdir);

	$destdir = File::Spec->catfile($csinstall_dir, "esmweb", "webgui", "sm", "config", "spring");
	copy($SXML1, $destdir);
	copy($SXML2, $destdir);

	my $smlibdir = File::Spec->catfile($csinstall_dir, "esmweb", "webgui", "sm", "WEB-INF", "lib");

	copy($JAR1, $smlibdir);

	copy($JAR2, $smlibdir);

	copy($JAR3, $smlibdir);

	$destdir = File::Spec->catfile($csinstall_dir, "esmweb", "webgui", "sm", "plugins");

	chdir($destdir);

	my $tar = Archive::Tar->new();
	my @filelist = $tar->read($TAR, 0, { extract=>1 } );

	if (VRTS::AddOnInfo::is_CS()) {
		
		my $dbisql = File::Spec->catfile($csinstall_dir, "config", "adm", "db_isql.sh");
		my $xdbadm = File::Spec->catfile($mhinstall_dir, "bin", "xdbadm");
		my $log_dir_cs = VRTS::Paths::get_path("AppDir");
		$log_dir_cs =~ s/VRTSsfmh/VRTSsfmcs/g;
		my $odbc_ini_dir = "/etc/vx/VRTSsfmcs";
		$odbc_ini_dir = $log_dir_cs if ( $^O =~ /Win32/i);
		my $cmd;

		if ($^O =~ /Win32/i) {
			$cmd = make_command($xdbadm, "-f", File::Spec->catfile($addon_dir, "cms", "VolTmpl.sql"),
									  "-o", File::Spec->catfile($odbc_ini_dir,".odbc.ini"),
									  "-c", File::Spec->catfile($log_dir_cs, "conf"),
									  "-d", "SFMdb3");
			

			


		} else {
			if (!defined $ENV{'SFMDBPASSWD'}) {
				open(HANDLE, $xdbadm." -g -u HABDBSYNC -c ".File::Spec->catfile($log_dir_cs, "conf")." -o ".File::Spec->catfile($odbc_ini_dir, ".odbc.ini"." |")) or $execute_error = 1;
				$pwd = <HANDLE>;
				chomp($pwd);
				close(HANDLE);
				$ENV{'SFMDBPASSWD'} = $pwd;
			}
			
			#Create DB tables
			
			$cmd = make_command($dbisql, "HABDBSYNC", File::Spec->catfile($addon_dir, "cms", "VolTmpl.sql"));
		}
			
		my $out = system($cmd);
		my $ret = $? >> 8;
		if ($ret) {
			print "VolTmpl View Creation Failed. error $out. rc $ret";
			exit($ret); 	
		}

		if ($^O =~ /Win32/i) {
			$cmd = make_command($xdbadm, "-f", File::Spec->catfile($addon_dir, "cms", "VolTmplMgr.sql"),
									  "-o", File::Spec->catfile($odbc_ini_dir,".odbc.ini"),
									  "-c", File::Spec->catfile($log_dir_cs, "conf"),
									  "-d", "SFMdb3");
		} else {
			if (!defined $ENV{'SFMDBPASSWD'}) {
				open(HANDLE, $xdbadm." -g -u HABDBSYNC -c ".File::Spec->catfile($log_dir_cs, "conf")." -o ".File::Spec->catfile($odbc_ini_dir, ".odbc.ini"." |")) or $execute_error = 1;
				$pwd = <HANDLE>;
				chomp($pwd);
				close(HANDLE);
				$ENV{'SFMDBPASSWD'} = $pwd;
			}
			
			#Create DB tables
			
			$cmd = make_command($dbisql, "HABDBSYNC", File::Spec->catfile($addon_dir, "cms", "VolTmplMgr.sql"));
		}
			
		$out = system($cmd);
		$ret = $? >> 8;
		if ($ret) {
			print "VolTmplMgr View Creation Failed. error $out. rc $ret";
			exit($ret); 	
		}

		if ($^O =~ /Win32/i) {
			$cmd = make_command($xdbadm, "-f", File::Spec->catfile($addon_dir, "cms", "VolTmplDst.sql"),
									  "-o", File::Spec->catfile($odbc_ini_dir,".odbc.ini"),
									  "-c", File::Spec->catfile($log_dir_cs, "conf"),
									  "-d", "SFMdb3");
		} else {
			if (!defined $ENV{'SFMDBPASSWD'}) {
				open(HANDLE, $xdbadm." -g -u HABDBSYNC -c ".File::Spec->catfile($log_dir_cs, "conf")." -o ".File::Spec->catfile($odbc_ini_dir, ".odbc.ini"." |")) or $execute_error = 1;
				$pwd = <HANDLE>;
				chomp($pwd);
				close(HANDLE);
				$ENV{'SFMDBPASSWD'} = $pwd;
			}
			
			#Create DB tables
			
			$cmd = make_command($dbisql, "HABDBSYNC", File::Spec->catfile($addon_dir, "cms", "VolTmplDst.sql"));
		}
			
		$out = system($cmd);
		$ret = $? >> 8;
		if ($ret) {
			print "DST Policies Creation Failed. error $out. rc $ret";
			exit($ret); 	
		}
	}
    foreach $extDir (@extractedHelpDirs)
    {
       VRTS::Util::copy_recursively(File::Spec->catdir($from_helpDir,$extDir),File::Spec->catdir($helpDir,$extDir));
    }
	print "Storage Provisioning Addon was successfully installed";
	exit(0);


